Attribute VB_Name = "scanner_functions"


Public Const file_name = 1
Public Const file_extension = 2


Private Sub OpenTokenForm()
Dim FDO$, FDOPath$
Dim Attach&, Edit&, OK&
   FDO$ = scanner_main.txtFDOCode.Text
   FDOPath$ = App.Path & "\TokenForm.fdo"
   SaveString FDO$, FDOPath$
   RunMenuByString "Play Text Stream..."
   Do: DoEvents
    Attach& = FindWindow("#32770", "Play Text File")
    Edit& = FindWindowEx(Attach&, 0&, "EDIT", vbNullString)
    OK& = FindWindowEx(Attach&, 0, "Button", "&Open")
   Loop Until Attach& And Edit& And OK&
   Do: DoEvents
    Call SendMessageByString(Edit&, WM_SETTEXT, 0, FDOPath$)
   Loop Until GetText(Edit&) = FDOPath$
   Call SendMessageByNum(OK&, WM_LBUTTONDOWN, 0&, 0&)
   Call SendMessageByNum(OK&, WM_LBUTTONUP, 0&, 0&)
   Do: DoEvents
   Loop Until FindWindowEx(AOLMDI&, 0&, "AOL Child", "Token Form")
End Sub

Sub LoadListHeaders()
    Dim objColumnHeader As ColumnHeader
    scanner_main.ListViewFiles.View = lvwReport
    scanner_main.ListViewFiles.ColumnHeaders.Clear
    Set objColumnHeader = scanner_main.ListViewFiles.ColumnHeaders.Add()
    objColumnHeader.Text = "Type"
    objColumnHeader.Width = 600
    Set objColumnHeader = scanner_main.ListViewFiles.ColumnHeaders.Add()
    objColumnHeader.Text = "File"
    objColumnHeader.Width = 1300
    Set objColumnHeader = scanner_main.ListViewFiles.ColumnHeaders.Add()
    objColumnHeader.Text = "Date"
    objColumnHeader.Width = 1000
    Set objColumnHeader = scanner_main.ListViewFiles.ColumnHeaders.Add()
    objColumnHeader.Text = "Author"
    objColumnHeader.Width = 1200
    Set objColumnHeader = scanner_main.ListViewFiles.ColumnHeaders.Add()
    objColumnHeader.Text = "Title"
    objColumnHeader.Width = 2000
    Set objColumnHeader = scanner_main.ListViewFiles.ColumnHeaders.Add()
    objColumnHeader.Text = "eB Lib"
    objColumnHeader.Width = 1000
    Set objColumnHeader = scanner_main.ListViewFiles.ColumnHeaders.Add()
    objColumnHeader.Text = "Arg."
    objColumnHeader.Width = 1200
End Sub

Sub AddToList_mF(Extension$, FileName$, rDate$, Author$, Title$, Lib$, Token$)
            'MsgBox Extension$
            Dim objListItem, objItemCell
            Set objListItem = scanner_main.ListViewFiles.ListItems.Add
            objListItem.Text = UCase(Extension$)
            Set objItemCell = objListItem.ListSubItems.Add
            objItemCell.Text = Trim(FileName$)
            Set objItemCell = objListItem.ListSubItems.Add
            objItemCell.Text = Trim(rDate$)
            Set objItemCell = objListItem.ListSubItems.Add
            objItemCell.Text = Trim(Author$)
            Set objItemCell = objListItem.ListSubItems.Add
            objItemCell.Text = Trim(Title$)
            Set objItemCell = objListItem.ListSubItems.Add
            objItemCell.Text = Trim(Lib$)
            Set objItemCell = objListItem.ListSubItems.Add
            objItemCell.Text = Trim(Token$)
End Sub

Sub SendToken(Arg$)
If TokenForm& = 0 Then OpenTokenForm
Do: DoEvents
    TokenBox& = FindWindowEx(TokenForm&, 0&, "_AOL_Edit", vbNullString)
    Data& = FindWindowEx(TokenForm&, TokenBox&, "_AOL_Edit", vbNullString)
    SendValue& = FindWindowEx(TokenForm&, 0&, "_AOL_Icon", vbNullString)
    SendValue& = FindWindowEx(TokenForm&, SendValue&, "_AOL_Icon", vbNullString)
Loop Until SendValue&
    ShowWindow TokenForm&, 1
    SendMessageByString TokenBox&, WM_SETTEXT, 0&, "mF"
    SendMessageByString Data&, WM_SETTEXT, 0&, Arg$
    SendMessageByNum Data&, WM_CHAR, 13, 0
End Sub

Function TokenForm() As Long
TokenForm& = FindWindowEx(AOLMDI&, 0&, "AOL Child", "Token Form")
End Function

Sub AddToList()
NewChild& = AOLChild&
AOLView& = FindWindowEx(NewChild&, 0&, "_AOL_View", vbNullString)
gettext1$ = GetText(AOLView&)
FullText$ = GetText(AOLView&)
   Spot1% = InStr(FullText$, "Subject:  ")
   Spot2% = InStr(Spot1% + 1, FullText$, vbCrLf)
Subject$ = Mid(FullText$, Spot1% + Len("Subject:  "), Spot2% - Spot1% - Len("Subject:  "))
If Subject$ = vbNullString Then Subject$ = "Untitled"
   Spot1% = InStr(FullText$, "Author:  ")
   Spot2% = InStr(Spot1% + 1, FullText$, vbCrLf)
Author$ = Mid(FullText$, Spot1% + Len("Author:  "), Spot2% - Spot1% - Len("Author:  "))
   Spot1% = InStr(FullText$, "Date:  ")
   Spot2% = InStr(Spot1% + 1, FullText$, vbCrLf)
rDate$ = Mid(FullText$, Spot1% + Len("Date:  "), Spot2% - Spot1% - Len("Date:  "))
   Spot1% = InStr(FullText$, "File:  ")
   Spot2% = InStr(Spot1% + 1, FullText$, vbCrLf)
FileFull$ = Mid(FullText$, Spot1% + Len("File:  "), Spot2% - Spot1% - Len("File:  "))
   FileName$ = ExtractInfo(FileFull$, file_name)
   FileExtension$ = ExtractInfo(FileFull$, file_extension)
AOLEdit& = FindWindowEx(NewChild&, 0&, "_AOL_Edit", vbNullString)
   LibNum$ = Mid(GetText(AOLEdit&), 12)
   If IsNumeric(LibNum$) = True Then LibKeyword$ = "eB " & LibNum$ Else LibKeyword$ = LibNum$
   If LibKeyword$ = "eB " Then LibKeyword$ = "-"
   'MsgBox FileFull$
   If scanner_main.chkEXE.Value = 1 Then
       If FileExtension$ = "EXE" Or FileExtension$ = "ZIP" Then
            AddToList_mF FileExtension$, FileName$, rDate$, Author$, Subject$, LibKeyword$, ("mF" & Chr(32) & scanner_main.text_prefix.Text & "-" & scanner_main.lblNow.Caption)
       End If
   Else
            AddToList_mF FileExtension$, FileName$, rDate$, Author$, Subject$, LibKeyword$, ("mF" & Chr(32) & scanner_main.text_prefix.Text & "-" & scanner_main.lblNow.Caption)
   End If

End Sub

Function ExtractInfo(FileName$, WhatType) As String
For o = 1 To Len(FileName$)
    Ending$ = Right(FileName$, o)
    Spot1$ = Left(Ending$, 1)
    If Spot1$ = "(" Then
        FileName$ = Trim(Left(FileName$, Len(FileName$) - o))
        Exit For
    End If
Next o
'MsgBox FileName$
    
    If InStr(FileName$, ".") = 0 Then
        If WhatType = 1 Then
            ExtractInfo$ = FileName$
            Exit Function
        ElseIf WhatType = 2 Then
            ExtractInfo$ = "-"
            Exit Function
        End If
    Else
    For i = 1 To Len(FileName$)
        Ending$ = Right(FileName$, i)
        Spot1$ = Left(Ending$, 1)
        If Spot1$ = "." Then
            If WhatType = 1 Then
                ExtractInfo$ = Left(FileName$, Len(FileName$) - i)
                Exit Function
            ElseIf WhatType = 2 Then
                ExtractInfo$ = UCase(Right(FileName$, i - 1))
                Exit Function
            End If
        End If
    Next i
    End If
End Function
