Attribute VB_Name = "token_scanner_mod"
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

Public Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Public Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Public Declare Function GetMenu Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Public Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long

Public Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Public Declare Function SendMessageByNum& Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
Public Declare Function SendMessageLong& Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, ByVal lParam As Long) As Long
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
Public Declare Function SetParent& Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long)
Public Declare Function GetDesktopWindow& Lib "user32" ()

Public Declare Function GetTickCount& Lib "kernel32" ()
Public Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String)

Public Declare Function EnableWindow Lib "user32" (ByVal hWnd As Long, ByVal CMD As Long) As Long

Public Const WM_COMMAND = &H111
Public Const WM_SETTEXT = &HC
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_GETTEXT = &HD
Public Const WM_GETTEXTLENGTH = &HE
Public Const WM_CLOSE = &H10
Public Const WM_CHAR = &H102

Public Function AOL() As Long
    AOL& = FindWindow("AOL Frame25", vbNullString)
End Function

Public Function AOLMDI() As Long
    AOLMDI& = FindWindowEx(AOL&, 0&, "MDIClient", vbNullString)
End Function

Public Function AOLChild() As Long
    AOLChild& = FindWindowEx(AOLMDI&, 0&, "AOL Child", vbNullString)
End Function

Public Function AolModal() As Long
    AolModal& = FindWindow("_AOL_Modal", vbNullString)
End Function

Public Function AOLMsg() As Long
    AOLMsg& = FindWindow("#32770", "America Online")
End Function

Public Function AOLWeb() As Long
    AOLWeb& = FindWindowEx(AOLChild&, 0&, "_AOL_WWWView", vbNullString)
End Function

Public Function GetWebURL() As String
    Dim ToolBar1&, ToolBar2&, ComboBox&, ComboCount&
    Dim comboLen&, pString$, Edit&
    ToolBar1 = FindWindowEx(AOL&, 0, "AOL Toolbar", vbNullString)
    ToolBar2 = FindWindowEx(ToolBar1, 0, "_AOL_Toolbar", vbNullString)
    ComboBox = FindWindowEx(ToolBar2, 0, "_AOL_Combobox", vbNullString)
    Edit& = FindWindowEx(ComboBox, 0, "Edit", vbNullString)
    GetWebURL$ = GetText(Edit&)
End Function

Public Sub RunMenuByString(MenuTitle As String)
    Dim MainMenu&, MenuCount&, SubMenu&, SubCount&, SearchMain&
    Dim SubID&, SearchSub&, MenuString$
    On Error Resume Next
    MainMenu& = GetMenu(AOL&)
    MenuCount& = GetMenuItemCount(MainMenu&)
    For SearchMain& = 0 To MenuCount& - 1
        SubMenu& = GetSubMenu(MainMenu&, SearchMain&)
        SubCount& = GetMenuItemCount(SubMenu&)
        For SearchSub& = 0 To SubCount& - 1
            SubID& = GetMenuItemID(SubMenu&, SearchSub&)
            MenuString$ = String$(255, Chr(32))
            Call GetMenuString(SubMenu&, SubID&, MenuString$, 100, 1&)
                If InStr(LCase(Trim(MenuString$)), LCase(Trim(MenuTitle$))) Then
                Call SendMessageLong(AOL&, WM_COMMAND, SubID&, 0&)
                Exit Sub
            End If
        Next SearchSub&
    Next SearchMain&
End Sub

Public Function SaveString(LString As String, FilePath$)
    On Error Resume Next
    Open FilePath$ For Output As #1
    Print #1, LString$
    Close #1
End Function

Public Function GetText(hWnd As Long) As String
 On Error Resume Next
 Dim GetLen As Integer, StringText As String, GetString As Long
 
 GetLen% = SendMessageByNum(hWnd&, WM_GETTEXTLENGTH, 0&, 0&)
 DoEvents
 If hWnd& = 0 Then GetText$ = 0: Exit Function
 StringText$ = String$(GetLen% + 1, 0)
 Call SendMessageByString(hWnd&, WM_GETTEXT, GetLen% + 1, StringText$)
 If InStr(StringText$, Chr(0)) = 0 Then GetText = StringText$ Else GetText$ = Left(StringText$, InStr(StringText$, Chr(0)) - 1)
End Function

Public Function GetCaption(hWnd As Long) As String
Dim HwndLength As Long, HwndTitle As String, FixTitle As String
 HwndLength& = GetWindowTextLength(hWnd&)
 HwndTitle$ = String$(HwndLength&, 0)
 FixTitle$ = GetWindowText(hWnd&, HwndTitle$, (HwndLength& + 1))
 GetCaption$ = HwndTitle$
End Function

Public Sub Timeout(sSeconds As Variant)
On Error Resume Next
 Dim StartTime&, curTime&
 sSeconds = sSeconds * 1000
 StartTime& = GetTickCount()
 Do: DoEvents
    curTime& = GetTickCount()
 Loop Until ((curTime& - StartTime&) > sSeconds)
End Sub

Public Sub ClickIcon(Icon As Long)
    Call SendMessage(Icon&, WM_LBUTTONDOWN, 0&, 0&)
    Call SendMessage(Icon&, WM_LBUTTONUP, 0&, 0&)
End Sub

Public Sub CloseWindow(hWnd As Long)
 Call PostMessage(hWnd&, WM_CLOSE, 0&, 0&)
End Sub

Function GetFromINI(AppName$, KeyName$, FileName$) As String
   Dim RetStr As String
   RetStr = String(255, Chr(0))
   GetFromINI = Left(RetStr, GetPrivateProfileString(AppName$, ByVal KeyName$, "", RetStr, Len(RetStr), FileName$))
End Function

Public Sub Loadlistbox(Directory As String, TheList As ListBox)
If FileExists(Directory$) = False Then Exit Sub
    Dim MyString As String
    On Error Resume Next
    Open Directory$ For Input As #1
    While Not EOF(1)
        Input #1, sString$
            sString$ = Replace(sString$, ",", "-")
            If sString$ <> "" Then TheList.AddItem sString$
        Wend
    Close #1
End Sub

Public Sub SaveListBox(Directory As String, TheList As ListBox)
Dim SaveList&
If TheList.ListCount = 0 Then Exit Sub
    On Error Resume Next
    Open Directory$ For Output As #1
    For SaveList& = 0 To TheList.ListCount - 1
        Print #1, TheList.List(SaveList&)
    Next SaveList&
    Close #1
End Sub

Public Function FileExists(FilePath As String) As Boolean
   If Len(Dir$(FilePath$)) <> 0 Then
       FileExists = True
   Else
       FileExists = False
   End If
End Function

Public Function LoadString(FilePath As String) As String
   Dim TextString As String
    On Error Resume Next
    Open FilePath$ For Input As #1
    TextString$ = Input(LOF(1), #1)
    Close #1
    LoadString$ = TextString$
End Function

